<?php
Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "twilio_api_call_log".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "TwilioApiCallLog".
 *
 * Columns in table "twilio_api_call_log" available as properties of the model,
 * and there are no model relations.
 *
 * @property integer $id
 * @property string $sid
 * @property string $date_created
 * @property string $date_updated
 * @property string $parent_call_sid
 * @property string $account_sid
 * @property string $to
 * @property string $to_formatted
 * @property string $from
 * @property string $from_formatted
 * @property string $phone_number_sid
 * @property string $status
 * @property string $start_time
 * @property string $end_time
 * @property string $duration
 * @property string $price
 * @property string $price_unit
 * @property string $direction
 * @property string $answered_by
 * @property string $annotation
 * @property string $api_version
 * @property string $forwarded_from
 * @property string $group_sid
 * @property string $caller_name
 * @property string $uri
 * @property string $subresource_uris
 *
 */
abstract class BaseTwilioApiCallLog extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'twilio_api_call_log';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'TwilioApiCallLog|TwilioApiCallLogs', $n);
    }

    public static function representingColumn()
    {
        return 'sid';
    }

    public function rules()
    {
        return array(
            array(
                'sid, parent_call_sid, account_sid, phone_number_sid',
                'length',
                'max' => 34
            ),
            array(
                'to, to_formatted, from, from_formatted, status, api_version, forwarded_from',
                'length',
                'max' => 20
            ),
            array(
                'duration, price, price_unit, direction',
                'length',
                'max' => 10
            ),
            array(
                'answered_by, annotation, group_sid, caller_name',
                'length',
                'max' => 30
            ),
            array(
                'uri',
                'length',
                'max' => 255
            ),
            array(
                'date_created, date_updated, start_time, end_time, subresource_uris',
                'safe'
            ),
            array(
                'sid, date_created, date_updated, parent_call_sid, account_sid, to, to_formatted, from, from_formatted, phone_number_sid, status, start_time, end_time, duration, price, price_unit, direction, answered_by, annotation, api_version, forwarded_from, group_sid, caller_name, uri, subresource_uris',
                'default',
                'setOnEmpty' => true,
                'value' => null
            ),
            array(
                'id, sid, date_created, date_updated, parent_call_sid, account_sid, to, to_formatted, from, from_formatted, phone_number_sid, status, start_time, end_time, duration, price, price_unit, direction, answered_by, annotation, api_version, forwarded_from, group_sid, caller_name, uri, subresource_uris',
                'safe',
                'on' => 'search'
            )
        );
    }

    public function relations()
    {
        return array();
    }

    public function pivotModels()
    {
        return array();
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'sid' => Yii::t('app', 'Sid'),
            'date_created' => Yii::t('app', 'Date Created'),
            'date_updated' => Yii::t('app', 'Date Updated'),
            'parent_call_sid' => Yii::t('app', 'Parent Call Sid'),
            'account_sid' => Yii::t('app', 'Account Sid'),
            'to' => Yii::t('app', 'To'),
            'to_formatted' => Yii::t('app', 'To Formatted'),
            'from' => Yii::t('app', 'From'),
            'from_formatted' => Yii::t('app', 'From Formatted'),
            'phone_number_sid' => Yii::t('app', 'Phone Number Sid'),
            'status' => Yii::t('app', 'Status'),
            'start_time' => Yii::t('app', 'Start Time'),
            'end_time' => Yii::t('app', 'End Time'),
            'duration' => Yii::t('app', 'Duration'),
            'price' => Yii::t('app', 'Price'),
            'price_unit' => Yii::t('app', 'Price Unit'),
            'direction' => Yii::t('app', 'Direction'),
            'answered_by' => Yii::t('app', 'Answered By'),
            'annotation' => Yii::t('app', 'Annotation'),
            'api_version' => Yii::t('app', 'Api Version'),
            'forwarded_from' => Yii::t('app', 'Forwarded From'),
            'group_sid' => Yii::t('app', 'Group Sid'),
            'caller_name' => Yii::t('app', 'Caller Name'),
            'uri' => Yii::t('app', 'Uri'),
            'subresource_uris' => Yii::t('app', 'Subresource Uris')
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria();

        $criteria->compare('id', $this->id);
        $criteria->compare('sid', $this->sid, true);
        $criteria->compare('date_created', $this->date_created, true);
        $criteria->compare('date_updated', $this->date_updated, true);
        $criteria->compare('parent_call_sid', $this->parent_call_sid, true);
        $criteria->compare('account_sid', $this->account_sid, true);
        $criteria->compare('to', $this->to, true);
        $criteria->compare('to_formatted', $this->to_formatted, true);
        $criteria->compare('from', $this->from, true);
        $criteria->compare('from_formatted', $this->from_formatted, true);
        $criteria->compare('phone_number_sid', $this->phone_number_sid, true);
        $criteria->compare('status', $this->status, true);
        $criteria->compare('start_time', $this->start_time, true);
        $criteria->compare('end_time', $this->end_time, true);
        $criteria->compare('duration', $this->duration, true);
        $criteria->compare('price', $this->price, true);
        $criteria->compare('price_unit', $this->price_unit, true);
        $criteria->compare('direction', $this->direction, true);
        $criteria->compare('answered_by', $this->answered_by, true);
        $criteria->compare('annotation', $this->annotation, true);
        $criteria->compare('api_version', $this->api_version, true);
        $criteria->compare('forwarded_from', $this->forwarded_from, true);
        $criteria->compare('group_sid', $this->group_sid, true);
        $criteria->compare('caller_name', $this->caller_name, true);
        $criteria->compare('uri', $this->uri, true);
        $criteria->compare('subresource_uris', $this->subresource_uris, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria
        ));
    }
}
